%NEW CODE FOR DETERMINATION OF 12 COMBUSTION PRODUCTS, FLAME TEMPERATURE
%AND LAMINAR BURNING VELOCITY
function [T,V,X]=New_code(F,AD,ID,ID2)
if ID>7 || ID<=0
    error 'ID dont found'
end

%Determination of the Reactants enthalpy in BTU/lbm
%Fuel
H_Data=readtable('REACTANTS ENTHALPY.xlsx');
H_Ad=readtable('DILUENTS ENTHALPY.xlsx');
if (ID2==0 && AD==0) || (ID2~=0 && AD==0)
n = H_Data.n(ID); 
m = H_Data.m(ID) ;
l = H_Data.l(ID) ;
k = H_Data.k(ID) ;
AVM_fuel = H_Data.AVM_kg_kmol_(ID) ;
Hf = H_Data.EntalpiaA0K_kJ_mol_(ID) ;
Hs = H_Data.CalorSensibleA298K_kJ_mol_(ID) ;
H_comb= Hf + Hs;

else 
n = (1-AD)*H_Data.n(ID) + AD*H_Ad.n(ID2);
m = (1-AD)*H_Data.m(ID) + AD*H_Ad.m(ID2);
l = (1-AD)*H_Data.l(ID) + AD*H_Ad.l(ID2);
k = (1-AD)*H_Data.k(ID) + AD*H_Ad.k(ID2);

AVM_fuel = (1-AD)*H_Data.AVM_kg_kmol_(ID) + AD*H_Ad.AVM_kg_kmol_(ID2);
Hf = (1-AD)*H_Data.EntalpiaA0K_kJ_mol_(ID) + AD*H_Ad.EntalpiaA0K_kJ_mol_(ID2);
Hs = (1-AD)*H_Data.CalorSensibleA298K_kJ_mol_(ID) + AD*H_Ad.CalorSensibleA298K_kJ_mol_(ID2);
H_comb= Hf + Hs;
end

%Air
coef_aire=(n+(m/4)-(l/2))/F;
%   O2    N2     AR
AVM=[32, 28.01, 39.94];
coef_ecu=[1, 3.7274, 0.0444];
AVM_aire=0;
for i=1:3
AVM_aire=AVM_aire+AVM(i)*coef_ecu(i)*coef_aire;

end
H_aire=8.683*coef_aire*coef_ecu(1)+8.67*coef_aire*coef_ecu(2)+6.197*coef_aire*coef_ecu(3);

HR=((H_aire+H_comb)*1000/(AVM_aire+AVM_fuel))/2.326; %BTU/lbm 

Ea=29675.7; %cal/mol   
% T: Temperature in Rankine
T=6000;

% P: Pressure in PSIA = 14.696
P=14.696;

%Determination of the molar fractions and derivatives
JF=0; %
FPR=0; %
TPR=1; %
PPR=1; %
X4PR=0;
X6PR=0;
X8PR=0;
X11PR=0;
for ITERATION=1:25

[JF,FPR,TPR,PPR,X4PR,X6PR,X8PR,X11PR,H,der_H_T,X]=Fractions_Derivatives(n,m,l,k,F,T,P,JF,FPR,TPR,PPR,X4PR,X6PR,X8PR,X11PR);

DELTA=(H-HR)/der_H_T;
T=T-DELTA;
if(abs(DELTA)<=1)
    %Determination of the laminar burning velocity using Mallard and Le
    %Chatelier method
    format shortG
    T=round(T*5/9,2);
    V=round(sqrt(exp(-Ea/(1.987*T)))*1000,2);
    break
end

end
end